import { Requests, Responses, UserRole, get_token, post_token } from './base';

export const get_users = (token: string): Promise<Responses.Admin.GetUsers> =>
	get_token('/api/admin/users', token);

export const set_role = (
	user: number,
	role: UserRole,
	token: string
): Promise<Responses.Admin.SetUserRole | Responses.ErrorResponse> =>
	post_token<Requests.Admin.SetUserRole>(
		'/api/admin/set_role',
		{
			user,
			role
		},
		token
	);

export const logout = (
	user: number,
	token: string
): Promise<Responses.Admin.LogoutAllUser | Responses.ErrorResponse> =>
	post_token<Requests.Admin.LogoutAll>(
		'/api/admin/logout',
		{
			user
		},
		token
	);

export const delete_user = (
	user: number,
	token: string
): Promise<Responses.Admin.DeleteUser | Responses.ErrorResponse> =>
	post_token<Requests.Admin.DeleteUser>(
		'/api/admin/delete',
		{
			user
		},
		token
	);

export const disable_tfa = (
	user: number,
	token: string
): Promise<Responses.Admin.DisableTfa | Responses.ErrorResponse> =>
	post_token<Requests.Admin.DisableTfa>(
		'/api/admin/disable_2fa',
		{
			user
		},
		token
	);
